#### Random Quotes add-on for mEL 1.6.0
#### (c)2002 Jules <mel@angelbears.org>
####
#### !quote ?nickname?
#### Searches the channel log for a random quote and displays it
#### in the channel.
####
#### mEL 2.0 needed
#### source it after mel2.tcl

bind pub - "!quote" ::mel::quote

if {![namespace exists ::mel]} {
	putlog "Random Quotes not functional without mEL 2.0!"
	unbind pub - "!quote" ::mel::quote
} else {
	putlog "Loading Random Quote script"
}

namespace eval mel {
	
	proc rq_fixquote {line} {
		regsub -all {\[} $line {\\[} line
		regsub -all {\]} $line {\\]} line
		regsub -all {\"} $line {\\"} line
		return $line
	}

	proc quote {nick host handle channel text} {
		variable actives
		foreach v $actives {variable $v}
		if {$text == ""} {set rq_query [string tolower $nick]} else {set rq_query [lindex [string tolower $text] 0]}
		foreach rq_nr [array names channels] { lappend rq_chanlist [string tolower $channels($rq_nr)] }
		if {$unixnames == 1} {set rq_chan [string tolower [string range $channel 1 end]]} else {set rq_chan [string tolower $channel]}
		if {[lsearch -exact $rq_chanlist [string tolower $channel]] == -1 || ![file exists [file join $statslogdir $rq_chan].log]} {
			putserv "PRIVMSG $channel : No random quote found for $rq_query!"
			putlog "RandomQuote: No such channel or logfile: $channel"
			return 0
		}
		set rq_lines -1
		set rq_read [open [file join $statslogdir $rq_chan].log r]
		while {![eof $rq_read]} {
			set rq_data [rq_fixquote [gets $rq_read]]
			if {[eof $rq_read]} {break}
			if {[string match -nocase [rq_fixquote $rq_query] [string trim [lindex $rq_data 1] <>]]} {
				incr rq_lines
				set rq_userlines($rq_lines) $rq_data
			}
		}
		close $rq_read
		if {$rq_lines == -1} {putserv "PRIVMSG $channel : No random quote found for $rq_query!" ; return 0}
		putserv "PRIVMSG $channel : [join $rq_userlines([rand $rq_lines])]"
		array unset rq_userlines
		return 0
	}

}
